
import { Subject } from 'rxjs';
import { GridView9Base } from '@/studio-core';
import HRArchivesMoveService from '@/service/hrarchives-move/hrarchives-move-service';
import HRArchivesMoveAuthService from '@/authservice/hrarchives-move/hrarchives-move-auth-service';
import GridView9Engine from '@engine/view/grid-view9-engine';
import HRArchivesMoveUIService from '@/uiservice/hrarchives-move/hrarchives-move-ui-service';
import CodeListService from "@service/app/codelist-service";


/**
 * 调档记录视图基类
 *
 * @export
 * @class HRArchivesMoveV_001Base
 * @extends {GridView9Base}
 */
export class HRArchivesMoveV_001Base extends GridView9Base {
    /**
     * 视图对应应用实体名称
     *
     * @protected
     * @type {string}
     * @memberof HRArchivesMoveV_001Base
     */
    protected appDeName: string = 'hrarchivesmove';

    /**
     * 应用实体主键
     *
     * @protected
     * @type {string}
     * @memberof HRArchivesMoveV_001Base
     */
    protected appDeKey: string = 'hrarchivesmoveid';

    /**
     * 应用实体主信息
     *
     * @protected
     * @type {string}
     * @memberof HRArchivesMoveV_001Base
     */
    protected appDeMajor: string = 'hrarchivesmovename';

    /**
     * 实体服务对象
     *
     * @type {HRArchivesMoveService}
     * @memberof HRArchivesMoveV_001Base
     */
    protected appEntityService: HRArchivesMoveService = new HRArchivesMoveService;

    /**
     * 实体权限服务对象
     *
     * @type HRArchivesMoveUIService
     * @memberof HRArchivesMoveV_001Base
     */
    public appUIService: HRArchivesMoveUIService = new HRArchivesMoveUIService(this.$store);


    /**
     * 计数器服务对象集合
     *
     * @protected
     * @type {Array<*>}
     * @memberof HRArchivesMoveV_001Base
     */    
    protected counterServiceArray: Array<any> = [];

    /**
     * 视图模型数据
     *
     * @protected
     * @type {*}
     * @memberof HRArchivesMoveV_001Base
     */
    protected model: any = {
        srfCaption: 'entities.hrarchivesmove.views.v_001.caption',
        srfTitle: 'entities.hrarchivesmove.views.v_001.title',
        srfSubTitle: 'entities.hrarchivesmove.views.v_001.subtitle',
        dataInfo: ''
    }

    /**
     * 容器模型
     *
     * @protected
     * @type {*}
     * @memberof HRArchivesMoveV_001Base
     */
    protected containerModel: any = {
        view_grid: { name: 'grid', type: 'GRID' },
    };


	/**
     * 视图唯一标识
     *
     * @protected
     * @type {string}
     * @memberof ViewBase
     */
	protected viewtag: string = 'b50ba73bdcf5631dc218cfb08097d534';


    /**
     * 视图引擎
     *
     * @public
     * @type {Engine}
     * @memberof HRArchivesMoveV_001Base
     */
    public engine: GridView9Engine = new GridView9Engine();

    /**
     * 引擎初始化
     *
     * @public
     * @memberof HRArchivesMoveV_001Base
     */
    public engineInit(): void {
        this.engine.init({
            view: this,
            opendata: (args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any) => {
                this.opendata(args,fullargs, params, $event, xData);
            },
            newdata: (args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any) => {
                this.newdata(args,fullargs, params, $event, xData);
            },
            grid: this.$refs.grid,
            keyPSDEField: 'hrarchivesmove',
            majorPSDEField: 'hrarchivesmovename',
            isLoadDefault: true,
        });
    }

    /**
     * grid 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRArchivesMoveV_001Base
     */
    public grid_selectionchange($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'selectionchange', $event);
    }

    /**
     * grid 部件 beforeload 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRArchivesMoveV_001Base
     */
    public grid_beforeload($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'beforeload', $event);
    }

    /**
     * grid 部件 rowdblclick 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRArchivesMoveV_001Base
     */
    public grid_rowdblclick($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'rowdblclick', $event);
    }

    /**
     * grid 部件 remove 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRArchivesMoveV_001Base
     */
    public grid_remove($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'remove', $event);
    }

    /**
     * grid 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRArchivesMoveV_001Base
     */
    public grid_load($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'load', $event);
    }

    /**
     * 打开新建数据视图
     *
     * @param {any[]} args
     * @param {*} [params]
     * @param {*} [fullargs]
     * @param {*} [$event]
     * @param {*} [xData]
     * @memberof HRArchivesMoveV_001
     */
    public newdata(args: any[],fullargs?:any[], params?: any, $event?: any, xData?: any) {
        let localContext:any = null;
        let localViewParam:any =null;
    this.$Notice.warning({ title: '错误', desc: '未指定关系视图' });
    }


    /**
     * 打开编辑数据视图
     *
     * @param {any[]} args
     * @param {*} [params]
     * @param {*} [fullargs]
     * @param {*} [$event]
     * @param {*} [xData]
     * @memberof HRArchivesMoveV_001
     */
    public opendata(args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any) {
    this.$Notice.warning({ title: '错误', desc: '未指定关系视图' });
    }


}