import { Prop, Provide, Emit, Model } from 'vue-property-decorator';
import { Subject, Subscription } from 'rxjs';
import { Watch, TabExpPanelControlBase } from '@/studio-core';
import HRArchivesService from '@/service/hrarchives/hrarchives-service';
import V_006tabexppanelService from './v-006tabexppanel-tabexppanel-service';
import HRArchivesUIService from '@/uiservice/hrarchives/hrarchives-ui-service';


/**
 * tabexppanel部件基类
 *
 * @export
 * @class TabExpPanelControlBase
 * @extends {V_006tabexppanelTabexppanelBase}
 */
export class V_006tabexppanelTabexppanelBase extends TabExpPanelControlBase {

    /**
     * 获取部件类型
     *
     * @protected
     * @type {string}
     * @memberof V_006tabexppanelTabexppanelBase
     */
    protected controlType: string = 'TABEXPPANEL';

    /**
     * 建构部件服务对象
     *
     * @type {V_006tabexppanelService}
     * @memberof V_006tabexppanelTabexppanelBase
     */
    public service: V_006tabexppanelService = new V_006tabexppanelService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {HRArchivesService}
     * @memberof V_006tabexppanelTabexppanelBase
     */
    public appEntityService: HRArchivesService = new HRArchivesService({ $store: this.$store });

    /**
     * 应用实体名称
     *
     * @protected
     * @type {string}
     * @memberof V_006tabexppanelTabexppanelBase
     */
    protected appDeName: string = 'hrarchives';

    /**
     * 应用实体中文名称
     *
     * @protected
     * @type {string}
     * @memberof V_006tabexppanelTabexppanelBase
     */
    protected appDeLogicName: string = '档案信息';
    /**
     * 是否初始化
     *
     * @protected
     * @returns {any}
     * @memberof V_006tabexppanel
     */
    protected isInit: any = {
        tabviewpanel:  true ,
        tabviewpanel2:  false ,
        tabviewpanel3:  false ,
        tabviewpanel4:  false ,
    }

    /**
     * 被激活的分页面板
     *
     * @protected
     * @type {string}
     * @memberof V_006tabexppanel
     */
    protected activatedTabViewPanel: string = 'tabviewpanel';

    /**
     * 组件创建完毕
     *
     * @protected
     * @memberof V_006tabexppanel
     */
    protected ctrlCreated(): void {
        //设置分页导航srfparentdename和srfparentkey
        if (this.context.hrarchives) {
            Object.assign(this.context, { srfparentdename: 'HRArchives', srfparentkey: this.context.hrarchives });
        }
        super.ctrlCreated();
    }
}