import { Http,Util,Errorlog } from '@/utils';
import ControlService from '@/widgets/control-service';
import HRArchivesService from '@/service/hrarchives/hrarchives-service';
import V_006tabexppanelModel from './v-006tabexppanel-tabexppanel-model';


/**
 * V_006tabexppanel 部件服务对象
 *
 * @export
 * @class V_006tabexppanelService
 */
export default class V_006tabexppanelService extends ControlService {

    /**
     * 档案信息服务对象
     *
     * @type {HRArchivesService}
     * @memberof V_006tabexppanelService
     */
    public appEntityService: HRArchivesService = new HRArchivesService({ $store: this.getStore() });

    /**
     * 设置从数据模式
     *
     * @type {boolean}
     * @memberof V_006tabexppanelService
     */
    public setTempMode(){
        this.isTempMode = false;
    }

    /**
     * Creates an instance of V_006tabexppanelService.
     * 
     * @param {*} [opts={}]
     * @memberof V_006tabexppanelService
     */
    constructor(opts: any = {}) {
        super(opts);
        this.model = new V_006tabexppanelModel();
    }

    
}