package cn.ibizlab.humanresource.core.humanresource.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.humanresource.util.domain.EntityBase;
import cn.ibizlab.humanresource.util.annotation.DEField;
import cn.ibizlab.humanresource.util.enums.DEPredefinedFieldType;
import cn.ibizlab.humanresource.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.humanresource.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.humanresource.util.domain.EntityMP;

/**
 * 实体[职称信息]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_HRTECHNICALTITLE",resultMap = "HRTechnicalTitleResultMap")
public class HRTechnicalTitle extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 职称信息标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "hrtechnicaltitleid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "hrtechnicaltitleid")
    @JsonProperty("hrtechnicaltitleid")
    private String hrtechnicaltitleid;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 职称名称
     */
    @TableField(value = "hrtechnicaltitlename")
    @JSONField(name = "hrtechnicaltitlename")
    @JsonProperty("hrtechnicaltitlename")
    private String hrtechnicaltitlename;
    /**
     * 员工标识
     */
    @TableField(value = "hremployeeid")
    @JSONField(name = "hremployeeid")
    @JsonProperty("hremployeeid")
    private String hremployeeid;
    /**
     * 员工姓名
     */
    @TableField(exist = false)
    @JSONField(name = "hremployeename")
    @JsonProperty("hremployeename")
    private String hremployeename;
    /**
     * 获取时间
     */
    @TableField(value = "titletime")
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "titletime" , format="yyyy-MM-dd")
    @JsonProperty("titletime")
    private Timestamp titletime;
    /**
     * 职称等级
     */
    @TableField(value = "titlelevel")
    @JSONField(name = "titlelevel")
    @JsonProperty("titlelevel")
    private String titlelevel;
    /**
     * 专业类别
     */
    @TableField(value = "majortype")
    @JSONField(name = "majortype")
    @JsonProperty("majortype")
    private String majortype;
    /**
     * 专业名称
     */
    @TableField(value = "major")
    @JSONField(name = "major")
    @JsonProperty("major")
    private String major;
    /**
     * 签发机构
     */
    @TableField(value = "authorganization")
    @JSONField(name = "authorganization")
    @JsonProperty("authorganization")
    private String authorganization;
    /**
     * 评审机构
     */
    @TableField(value = "validorganization")
    @JSONField(name = "validorganization")
    @JsonProperty("validorganization")
    private String validorganization;
    /**
     * 最高职称
     */
    @TableField(value = "hightitle")
    @JSONField(name = "hightitle")
    @JsonProperty("hightitle")
    private Integer hightitle;
    /**
     * 附件
     */
    @TableField(value = "attachment")
    @JSONField(name = "attachment")
    @JsonProperty("attachment")
    private String attachment;
    /**
     * 证书编号
     */
    @TableField(value = "certificatecode")
    @JSONField(name = "certificatecode")
    @JsonProperty("certificatecode")
    private String certificatecode;
    /**
     * 员工编号
     */
    @TableField(exist = false)
    @JSONField(name = "employeecode")
    @JsonProperty("employeecode")
    private String employeecode;
    /**
     * 单位
     */
    @TableField(exist = false)
    @JSONField(name = "organizationname")
    @JsonProperty("organizationname")
    private String organizationname;
    /**
     * 单位ID
     */
    @TableField(exist = false)
    @JSONField(name = "organizationid")
    @JsonProperty("organizationid")
    private String organizationid;
    /**
     * 员工状态
     */
    @TableField(exist = false)
    @JSONField(name = "empstate")
    @JsonProperty("empstate")
    private String empstate;

    /**
     * 员工
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.humanresource.core.humanresource.domain.HREmployee hremployee;



    /**
     * 设置 [职称名称]
     */
    public void setHrtechnicaltitlename(String hrtechnicaltitlename){
        this.hrtechnicaltitlename = hrtechnicaltitlename ;
        this.modify("hrtechnicaltitlename",hrtechnicaltitlename);
    }

    /**
     * 设置 [员工标识]
     */
    public void setHremployeeid(String hremployeeid){
        this.hremployeeid = hremployeeid ;
        this.modify("hremployeeid",hremployeeid);
    }

    /**
     * 设置 [获取时间]
     */
    public void setTitletime(Timestamp titletime){
        this.titletime = titletime ;
        this.modify("titletime",titletime);
    }

    /**
     * 格式化日期 [获取时间]
     */
    public String formatTitletime(){
        if (this.titletime == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(titletime);
    }
    /**
     * 设置 [职称等级]
     */
    public void setTitlelevel(String titlelevel){
        this.titlelevel = titlelevel ;
        this.modify("titlelevel",titlelevel);
    }

    /**
     * 设置 [专业类别]
     */
    public void setMajortype(String majortype){
        this.majortype = majortype ;
        this.modify("majortype",majortype);
    }

    /**
     * 设置 [专业名称]
     */
    public void setMajor(String major){
        this.major = major ;
        this.modify("major",major);
    }

    /**
     * 设置 [签发机构]
     */
    public void setAuthorganization(String authorganization){
        this.authorganization = authorganization ;
        this.modify("authorganization",authorganization);
    }

    /**
     * 设置 [评审机构]
     */
    public void setValidorganization(String validorganization){
        this.validorganization = validorganization ;
        this.modify("validorganization",validorganization);
    }

    /**
     * 设置 [最高职称]
     */
    public void setHightitle(Integer hightitle){
        this.hightitle = hightitle ;
        this.modify("hightitle",hightitle);
    }

    /**
     * 设置 [附件]
     */
    public void setAttachment(String attachment){
        this.attachment = attachment ;
        this.modify("attachment",attachment);
    }

    /**
     * 设置 [证书编号]
     */
    public void setCertificatecode(String certificatecode){
        this.certificatecode = certificatecode ;
        this.modify("certificatecode",certificatecode);
    }


}


