package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRPatent;
import cn.ibizlab.humanresource.core.humanresource.filter.HRPatentSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRPatent] 服务对象接口
 */
public interface IHRPatentService extends IService<HRPatent>{

    boolean create(HRPatent et) ;
    void createBatch(List<HRPatent> list) ;
    boolean update(HRPatent et) ;
    void updateBatch(List<HRPatent> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRPatent get(String key) ;
    HRPatent getDraft(HRPatent et) ;
    boolean checkKey(HRPatent et) ;
    boolean save(HRPatent et) ;
    void saveBatch(List<HRPatent> list) ;
    Page<HRPatent> searchDefault(HRPatentSearchContext context) ;
    List<HRPatent> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRPatent> getHrpatentByIds(List<String> ids) ;
    List<HRPatent> getHrpatentByEntities(List<HRPatent> entities) ;
}


