package cn.ibizlab.humanresource.hrapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;
import cn.ibizlab.humanresource.util.domain.DTOBase;
import cn.ibizlab.humanresource.util.domain.DTOClient;
import lombok.Data;

/**
 * 服务DTO对象[HRArchivesMoveDTO]
 */
@Data
public class HRArchivesMoveDTO extends DTOBase implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [HRARCHIVESMOVEID]
     *
     */
    @JSONField(name = "hrarchivesmoveid")
    @JsonProperty("hrarchivesmoveid")
    private String hrarchivesmoveid;

    /**
     * 属性 [HRARCHIVESMOVENAME]
     *
     */
    @JSONField(name = "hrarchivesmovename")
    @JsonProperty("hrarchivesmovename")
    private String hrarchivesmovename;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;

    /**
     * 属性 [HRARCHIVESID]
     *
     */
    @JSONField(name = "hrarchivesid")
    @JsonProperty("hrarchivesid")
    private String hrarchivesid;

    /**
     * 属性 [MOVETYPE]
     *
     */
    @JSONField(name = "movetype")
    @JsonProperty("movetype")
    private String movetype;

    /**
     * 属性 [MOVEINORG]
     *
     */
    @JSONField(name = "moveinorg")
    @JsonProperty("moveinorg")
    private String moveinorg;

    /**
     * 属性 [MOVEOUTORG]
     *
     */
    @JSONField(name = "moveoutorg")
    @JsonProperty("moveoutorg")
    private String moveoutorg;

    /**
     * 属性 [ACTIVETIME]
     *
     */
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "activetime" , format="yyyy-MM-dd")
    @JsonProperty("activetime")
    private Timestamp activetime;

    /**
     * 属性 [MEMO]
     *
     */
    @JSONField(name = "memo")
    @JsonProperty("memo")
    private String memo;


    /**
     * 设置 [HRARCHIVESMOVENAME]
     */
    public void setHrarchivesmovename(String  hrarchivesmovename){
        this.hrarchivesmovename = hrarchivesmovename ;
        this.modify("hrarchivesmovename",hrarchivesmovename);
    }

    /**
     * 设置 [HRARCHIVESID]
     */
    public void setHrarchivesid(String  hrarchivesid){
        this.hrarchivesid = hrarchivesid ;
        this.modify("hrarchivesid",hrarchivesid);
    }

    /**
     * 设置 [MOVETYPE]
     */
    public void setMovetype(String  movetype){
        this.movetype = movetype ;
        this.modify("movetype",movetype);
    }

    /**
     * 设置 [MOVEINORG]
     */
    public void setMoveinorg(String  moveinorg){
        this.moveinorg = moveinorg ;
        this.modify("moveinorg",moveinorg);
    }

    /**
     * 设置 [MOVEOUTORG]
     */
    public void setMoveoutorg(String  moveoutorg){
        this.moveoutorg = moveoutorg ;
        this.modify("moveoutorg",moveoutorg);
    }

    /**
     * 设置 [ACTIVETIME]
     */
    public void setActivetime(Timestamp  activetime){
        this.activetime = activetime ;
        this.modify("activetime",activetime);
    }

    /**
     * 设置 [MEMO]
     */
    public void setMemo(String  memo){
        this.memo = memo ;
        this.modify("memo",memo);
    }


}

