package cn.ibizlab.humanresource.hrapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;
import cn.ibizlab.humanresource.util.domain.DTOBase;
import cn.ibizlab.humanresource.util.domain.DTOClient;
import lombok.Data;

/**
 * 服务DTO对象[HREmpStateDTO]
 */
@Data
public class HREmpStateDTO extends DTOBase implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;

    /**
     * 属性 [HREMPSTATEID]
     *
     */
    @JSONField(name = "hrempstateid")
    @JsonProperty("hrempstateid")
    private String hrempstateid;

    /**
     * 属性 [HREMPSTATENAME]
     *
     */
    @JSONField(name = "hrempstatename")
    @JsonProperty("hrempstatename")
    private String hrempstatename;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;

    /**
     * 属性 [JOBSTATE]
     *
     */
    @JSONField(name = "jobstate")
    @JsonProperty("jobstate")
    private String jobstate;

    /**
     * 属性 [SHOWORDER]
     *
     */
    @JSONField(name = "showorder")
    @JsonProperty("showorder")
    private BigInteger showorder;

    /**
     * 属性 [STATECODE]
     *
     */
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private String statecode;


    /**
     * 设置 [HREMPSTATENAME]
     */
    public void setHrempstatename(String  hrempstatename){
        this.hrempstatename = hrempstatename ;
        this.modify("hrempstatename",hrempstatename);
    }

    /**
     * 设置 [JOBSTATE]
     */
    public void setJobstate(String  jobstate){
        this.jobstate = jobstate ;
        this.modify("jobstate",jobstate);
    }

    /**
     * 设置 [SHOWORDER]
     */
    public void setShoworder(BigInteger  showorder){
        this.showorder = showorder ;
        this.modify("showorder",showorder);
    }

    /**
     * 设置 [STATECODE]
     */
    public void setStatecode(String  statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }


}

